# buildforkernels macro hint: when you build a new version or a new release
# that contains bugfixes or other improvements then you must disable the
# "buildforkernels newest" macro for just that build; immediately after
# queuing that build enable the macro again for subsequent builds; that way
# a new akmod package will only get build when a new one is actually needed
#define buildforkernels newest

#Global definitions
%global         nvidiaserie       beta

Name:           nvidia-beta-kmod
Version:        190.36
Release:        1%{?dist}
Summary:        NVIDIA %{?nvidiaserie} display driver kernel module

Group:          System Environment/Kernel
License:        Redistributable, no modification permitted
URL:            http://www.nvidia.com/
# Source is created from these files:
#ftp://download.nvidia.com/XFree86/Linux-x86/%{version}/NVIDIA-Linux-x86-%{version}-pkg0.run
#ftp://download.nvidia.com/XFree86/Linux-x86_64/%{version}/NVIDIA-Linux-x86_64-%{version}-pkg0.run

# <switch me> when sources are on kwizart's repo
Source0:        http://rpms.kwizart.net/fedora/SOURCES/nvidia-kmod-data-%{version}.tar.bz2
#Source0:        http://www.diffingo.com/downloads/livna/kmod-data/nvidia-kmod-data-%{version}.tar.bz2
# </switch me>

Source11:       nvidia-kmodtool-excludekernel-filterfile
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i586 i686 x86_64

# get the needed BuildRequires (in parts depending on what we build for)
BuildRequires:  %{_bindir}/kmodtool
%{!?kernels:BuildRequires: buildsys-build-rpmfusion-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }
# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo rpmfusion --kmodname %{name} --filterfile %{SOURCE11} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }
 

%description
The nvidia %{?nvidiaserie} display driver kernel module version %{version}
for kernel %{kversion}.

%prep
# error out if there was something wrong with kmodtool
%{?kmodtool_check}
# print kmodtool output for debugging purposes:
kmodtool  --target %{_target_cpu}  --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null
%setup -q -c -T -a 0

# patch loop
#for arch in x86 x64
#do
#    pushd nvidiapkg-${arch}
# empty
#    popd
#done

for kernel_version  in %{?kernel_versions} ; do
%ifarch %{ix86}
    cp -a nvidiapkg-x86 _kmod_build_${kernel_version%%___*}
%else
    cp -a nvidiapkg-x64 _kmod_build_${kernel_version%%___*}
%endif
done


%build
for kernel_version in %{?kernel_versions}; do
    pushd _kmod_build_${kernel_version%%___*}/usr/src/nv/
    ln -s -f Makefile.kbuild Makefile
        if [[ "${kernel_version%%___*}" = *xen ]] ; then
            CC="cc -D__XEN_TOOLS__ \
            -I${kernel_version##*___}/include/asm/mach-xen" \
            IGNORE_XEN_PRESENCE=1 \
            make SYSSRC="${kernel_version##*___}" \
            %{?nvidiaserie:MODULE_NAME="nvidia_%{?nvidiaserie}"} \
              module
        else
            IGNORE_XEN_PRESENCE=1 \
            make SYSSRC="${kernel_version##*___}" \
            %{?nvidiaserie:MODULE_NAME="nvidia_%{?nvidiaserie}"} \
              module
        fi
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kernel_version in %{?kernel_versions}; do
  install -D -m 0755 _kmod_build_${kernel_version%%___*}/usr/src/nv/*.ko \
  $RPM_BUILD_ROOT/%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}/nvidia%{?nvidiaserie:_%{?nvidiaserie}}.ko
  ln -sf nvidia%{?nvidiaserie:_%{?nvidiaserie}}.ko \
  $RPM_BUILD_ROOT/%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}/nvidia.ko
done
%{?akmod_install}


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Tue Oct 13 2009 kwizart < kwizart at gmail.com > - 190.36-1
- Update to 190.36 (beta)

* Fri Aug  7 2009 kwizart < kwizart at gmail.com > - 185.19-1
- Update to 185.19 (beta)

* Mon Apr  7 2009 kwizart < kwizart at gmail.com > - 185.18.10-1
- Spec file rewrite.

